/* ToneMatrix - main.h
 * Copyright (c) 2011 Tanner Babcock */
/* beta 0.7 */
#ifndef MAIN_H
#define MAIN_H

#include <oslib/oslib.h>
#include <pspmodulemgr.h>

#define VERSION "0.7"
#define bool char
#define tmAbort(x) \
	tmDebug(10, x, "Getting TFO..."); \
	sceKernelExitGame()

#define OFFC RGBA(30,30,30,255)		// off
#define ONC RGBA(199,199,199,255)	// on
#define HOFF RGBA(50,50,50,255)		// lit up and off
#define HON RGBA(220,220,220,255)	// lit up and on
#define MOFF RGBA(40,0,0,255)		// off, row muted
#define MON RGBA(199,0,0,255)		// on, row muted
#define MHOFF RGBA(60,0,0,255)		// lit up and off, row muted
#define MHON RGBA(220,0,0,255)		// lit up and on, row muted
#define SOFF RGBA(0,7,40,255)		// off, row soloed
#define SON RGBA(0,8,199,255)		// on, row soloed
#define SHOFF RGBA(0,7,60,255)		// lit up and off, row soloed
#define SHON RGBA(0,8,220,255)		// lit up and on, row soloed

#define x1form ((x*30)-29)
#define y1form ((15+(y*30))-29)
#define x2form ((x*30)-1)
#define y2form ((15+(y*30))-1)

enum { FALSE, TRUE };
enum { OFF, ON, CURSOFF, CURSON };
enum { STOPM, HELPM, TEMPOM, CLEARM, QUITM };

int 	col, bpm, solo;
char 	grid[16][8];
double 	tempo;
bool 	mute[8];
bool 	quit, isplaying;
// keep bool quit, it controls sound thread
SceUID 	soundloop;
OSL_SOUND *sound[8];
OSL_IMAGE *select;

void 	tmInit(void);
void 	tmDebug(int x, int y, const char *str);
void 	tmWait(float sec);
void 	*tmSoundloop(void *arg);
void 	tmMainloop(void);
void 	tmDrawgrid(void);
void 	tmHelp(void);
void 	setUpVirtualFileMenu(void);

int 	tmMenu(void);
void 	tmClear(void);
double 	tmTempo(int b);
int 	tmBPM(double t);

void	tmMutecheck(void);	// makes sure mute and solo aren't both on
bool	tmMuteEmpty(bool m[8]); // is the mute array empty?

#endif
